/* 
 * @Program for Preventing Expansion of Entity References While Parsing an XML File
 * PreventingExpansionofEntityReferences.java 
 * Author:-RoseIndia Team
 * Date:-21-July-2008
 */

import java.io.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class PreventingExpansionofEntityReferences {

    public static void main(String[] args) throws Exception {
        File f = new File("Document4.xml");
        DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
 //Specifies that the parser produced by this code will expand entity reference nodes
        builderFactory.setExpandEntityReferences(false);
        DocumentBuilder builder = builderFactory.newDocumentBuilder();
        Document doc = builder.parse(f);

        TransformerFactory transformerFactory = TransformerFactory.newInstance();
        Transformer transformer = transformerFactory.newTransformer();
        transformer.setOutputProperty(OutputKeys.INDENT, "yes");

        StringWriter writer = new StringWriter();
        StreamResult result = new StreamResult(writer);
        DOMSource source = new DOMSource(doc);
        transformer.transform(source, result);
        String xmlfile=writer.toString();
        System.out.println(xmlfile);

    }
}
